
C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/ICON/src/mech_conv/radm2_to_cb05/cb05_table.f,v 1.1 2011/09/12 16:31:34 yoj Exp $

      module cb05_table

      integer, parameter :: nsptab = 44    ! No. of CB05 defined in this table
      integer, parameter :: mxcvsp = 9     ! Max no. of RADM species required for a table species

      type mech_conv
         character( 16 ) :: tab_spc       ! table spec names
         integer         :: n_radm2_spc   ! no. of RADM2 species defining each table species
         character( 16 ) :: radm2_spc( mxcvsp )
         real            :: coeff( mxcvsp )
      end type mech_conv

      type ( mech_conv ), parameter :: spcmap( nsptab ) = (/
C                 tab_spc    n_radm_spc                       radm2_spc( 9 )       coeff( 9 )
     & mech_conv( 'NO2    ', 1, (/'NO2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'NO     ', 1, (/'NO     ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'O      ', 1, (/'O3P    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'O3     ', 1, (/'O3     ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'NO3    ', 1, (/'NO3    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'O1D    ', 1, (/'O1D    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'OH     ', 1, (/'HO     ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'HO2    ', 1, (/'HO2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'N2O5   ', 1, (/'N2O5   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'HNO3   ', 1, (/'HNO3   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'HONO   ', 1, (/'HONO   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'PNA    ', 1, (/'HNO4   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'H2O2   ', 1, (/'H2O2   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'CO     ', 1, (/'CO     ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'SO2    ', 1, (/'SO2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'SULF   ', 1, (/'SULF   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'PAN    ', 1, (/'PAN    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'FACD   ', 1, (/'ORA1   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'AACD   ', 1, (/'ORA2   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'PACD   ', 1, (/'PAA    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'MEPX   ', 1, (/'OP1    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'MGLY   ', 1, (/'MGLY   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'OPEN   ', 1, (/'DCB    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'CRES   ', 1, (/'CSL    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'FORM   ', 2, (/'HCHO   ','GLY    ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)), 
     & mech_conv( 'ALD2   ', 1, (/'ALD    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'PAR    ', 9, (/'HC3    ','HC5    ','HC8    ','OLT    ','OLI    ','KET    ','GLY    ','TOL    ','XYL    '/),
     &                          (/ 2.9,      4.8,      7.9,      1.8,      0.8,      3.9,      1.0,      0.1,      0.9    /)),
     & mech_conv( 'OLE    ', 1, (/'OLT    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'TOL    ', 1, (/'TOL    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'ISOP   ', 1, (/'ISO    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'ETH    ', 1, (/'OL2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'XYL    ', 1, (/'XYL    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'TERP   ', 1, (/'TERP   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'ETHA   ', 1, (/'ETH    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'IOLE   ', 1, (/'OLI    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'MEO2   ', 1, (/'MO2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'ROOH   ', 1, (/'OP2    ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'NTR    ', 1, (/'ONIT   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'C2O3   ', 1, (/'ACO3   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'PANX   ', 1, (/'TPAN   ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'ISPD   ', 1, (/'ISOPROD','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'BENZENE', 1, (/'BENZENE','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'HG     ', 1, (/'HG     ','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)),
     & mech_conv( 'HGIIGAS', 1, (/'HGIIGAS','       ','       ','       ','       ','       ','       ','       ','       '/),
     &                          (/ 1.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0,      0.0    /)) /)

      character( 128 ) :: line1 = " CB05 gas mechanism with AERO5 species and toxics"
!     character( 128 ) :: out_fl_name = "/home/yoj/src/icon/mech_conv/radm2_to_cb05/ic_profile_CBO5.dat"
      include './out_fl_name.ext'
      character(  48 ) :: str = ' in RADM2 part of CB05 list, not in profile data'

      end module cb05_table
